# constants.coffee - Schema Object Model constants
#
# Copyright (C) 2013 Crowd Favorite, Ltd. All rights reserved.
#
# This file is part of Textorum.
#
# Textorum is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the
# Free Software Foundation; either version 2 of the License, or (at your
# option) any later version.
#
# Textorum is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.

define (require) ->
  # tagDOMNodeType
  NODE_INVALID: 0
  NODE_ELEMENT: 1
  NODE_ATTRIBUTE: 2
  NODE_TEXT: 3
  NODE_CDATA_SECTION: 4
  NODE_ENTITY_REFERENCE: 5
  NODE_ENTITY: 6
  NODE_PROCESSING_INSTRUCTION: 7
  NODE_COMMENT: 8
  NODE_DOCUMENT: 9
  NODE_DOCUMENT_TYPE: 10
  NODE_DOCUMENT_FRAGMENT: 11
  NODE_NOTATION: 12

  # SOMITEMTYPE
  SOMITEM_SCHEMA: 0x1000
  SOMITEM_ATTRIBUTE: 0x1001
  SOMITEM_ATTRIBUTEGROUP: 0x1002
  SOMITEM_NOTATION: 0x1003
  SOMITEM_IDENTITYCONSTRAINT: 0x1100
  SOMITEM_KEY: 0x1101
  SOMITEM_KEYREF: 0x1102
  SOMITEM_UNIQUE: 0x1103
  SOMITEM_ANYTYPE: 0x2000
  SOMITEM_DATATYPE: 0x2100
  SOMITEM_DATATYPE_ANYTYPE: 0x2101
  SOMITEM_DATATYPE_ANYURI: 0x2102
  SOMITEM_DATATYPE_BASE64BINARY: 0x2103
  SOMITEM_DATATYPE_BOOLEAN: 0x2104
  SOMITEM_DATATYPE_BYTE: 0x2105
  SOMITEM_DATATYPE_DATE: 0x2106
  SOMITEM_DATATYPE_DATETIME: 0x2107
  SOMITEM_DATATYPE_DAY: 0x2108
  SOMITEM_DATATYPE_DECIMAL: 0x2109
  SOMITEM_DATATYPE_DOUBLE: 0x210A
  SOMITEM_DATATYPE_DURATION: 0x210B
  SOMITEM_DATATYPE_ENTITIES: 0x210C
  SOMITEM_DATATYPE_ENTITY: 0x210D
  SOMITEM_DATATYPE_FLOAT: 0x210E
  SOMITEM_DATATYPE_HEXBINARY: 0x210F
  SOMITEM_DATATYPE_ID: 0x2110
  SOMITEM_DATATYPE_IDREF: 0x2111
  SOMITEM_DATATYPE_IDREFS: 0x2112
  SOMITEM_DATATYPE_INT: 0x2113
  SOMITEM_DATATYPE_INTEGER: 0x2114
  SOMITEM_DATATYPE_LANGUAGE: 0x2115
  SOMITEM_DATATYPE_LONG: 0x2116
  SOMITEM_DATATYPE_MONTH: 0x2117
  SOMITEM_DATATYPE_MONTHDAY: 0x2118
  SOMITEM_DATATYPE_NAME: 0x2119
  SOMITEM_DATATYPE_NCNAME: 0x211A
  SOMITEM_DATATYPE_NEGATIVEINTEGER: 0x211B
  SOMITEM_DATATYPE_NMTOKEN: 0x211C
  SOMITEM_DATATYPE_NMTOKENS: 0x211D
  SOMITEM_DATATYPE_NONNEGATIVEINTEGER: 0x211E
  SOMITEM_DATATYPE_NONPOSITIVEINTEGER: 0x211F
  SOMITEM_DATATYPE_NORMALIZEDSTRING: 0x2120
  SOMITEM_DATATYPE_NOTATION: 0x2121
  SOMITEM_DATATYPE_POSITIVEINTEGER: 0x2122
  SOMITEM_DATATYPE_QNAME: 0x2123
  SOMITEM_DATATYPE_SHORT: 0x2124
  SOMITEM_DATATYPE_STRING: 0x2125
  SOMITEM_DATATYPE_TIME: 0x2126
  SOMITEM_DATATYPE_TOKEN: 0x2127
  SOMITEM_DATATYPE_UNSIGNEDBYTE: 0x2128
  SOMITEM_DATATYPE_UNSIGNEDINT: 0x2129
  SOMITEM_DATATYPE_UNSIGNEDLONG: 0x212A
  SOMITEM_DATATYPE_UNSIGNEDSHORT: 0x212B
  SOMITEM_DATATYPE_YEAR: 0x212C
  SOMITEM_DATATYPE_YEARMONTH: 0x212D
  SOMITEM_DATATYPE_ANYSIMPLETYPE: 0x21FF
  SOMITEM_SIMPLETYPE: 0x2200
  SOMITEM_COMPLEXTYPE: 0x2400
  SOMITEM_PARTICLE: 0x4000
  SOMITEM_ANY: 0x4001
  SOMITEM_ANYATTRIBUTE: 0x4002
  SOMITEM_ELEMENT: 0x4003
  SOMITEM_GROUP: 0x4100
  SOMITEM_ALL: 0x4101
  SOMITEM_CHOICE: 0x4102
  SOMITEM_SEQUENCE: 0x4103
  SOMITEM_EMPTYPARTICLE: 0x4104
  SOMITEM_NULL: 0x0800
  SOMITEM_NULL_TYPE: 0x2800
  SOMITEM_NULL_ANY: 0x4801
  SOMITEM_NULL_ANYATTRIBUTE: 0x4802
  SOMITEM_NULL_ELEMENT: 0x4803

  # SCHEMAUSE
  SCHEMAUSE_OPTIONAL: 0
  SCHEMAUSE_PROHIBITED: 1
  SCHEMAUSE_REQUIRED: 2

  # SCHEMADERIVATIONMETHOD
  SCHEMADERIVATIONMETHOD_EMPTY: 0x0000
  SCHEMADERIVATIONMETHOD_SUBSTITUTION: 0x0001
  SCHEMADERIVATIONMETHOD_EXTENSION: 0x0002
  SCHEMADERIVATIONMETHOD_RESTRICTION: 0x0004
  SCHEMADERIVATIONMETHOD_LIST: 0x0008
  SCHEMADERIVATIONMETHOD_UNION: 0x0010
  SCHEMADERIVATIONMETHOD_ALL: 0x00FF
  SCHEMADERIVATIONMETHOD_NONE: 0x0100

  # SCHEMACONTENTTYPE
  SCHEMACONTENTTYPE_EMPTY: 0
  SCHEMACONTENTTYPE_TEXTONLY: 1
  SCHEMACONTENTTYPE_ELEMENTONLY: 2
  SCHEMACONTENTTYPE_MIXED: 3

  # SCHEMAPROCESSCONTENTS
  SCHEMAPROCESSCONTENTS_NONE: 0
  SCHEMAPROCESSCONTENTS_SKIP: 1
  SCHEMAPROCESSCONTENTS_LAX: 2
  SCHEMAPROCESSCONTENTS_STRICT: 3

  # SCHEMAWHITESPACE
  SCHEMAWHITESPACE_NONE: -1
  SCHEMAWHITESPACE_PRESERVE: 0
  SCHEMAWHITESPACE_REPLACE: 1
  SCHEMAWHITESPACE_COLLAPSE: 2

  # SCHEMATYPEVARIETY
  SCHEMATYPEVARIETY_NONE: -1
  SCHEMATYPEVARIETY_ATOMIC: 0
  SCHEMATYPEVARIETY_LIST: 1
  SCHEMATYPEVARIETY_UNION: 2

# Generated from the WINE msxml files:
# 
# http://source.winehq.org/git/wine.git/blob/HEAD:/include/msxml6.idl
#
# Perl to generate:
#
# ```perl
# BEGIN { my $enumblock = 0;  my $current; }
# if (/^}/) {
#   $enumblock = 0;
# }
# if ($enumblock) {
#   if (/([-_a-zA-Z0-9]+)\s+=\s+([-0-9A-Fx]+)/) {
#     $current = $2;
#     print "  $1: $2\n";
#   }
#   elsif (/([-_a-zA-Z0-9]+),?/) {
#     print "  $1: $current\n";
#     $current = $current + 1;
#   }
# }
# if (/^typedef enum _?([a-zA-Z]+)/) {
#   $enumblock = 1;
#   $current = 0;
#   print "\n  # $1\n";
# }
# ```
